Loading...
Searching...
No Matches
sensors.h File Reference
`#include <uhd/config.h>`
`#include <uhd/error.h>`
Include dependency graph for sensors.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Typedefs

typedef struct uhd_sensor_value_t * | uhd_sensor_value_handle
| C-level interface for a UHD sensor.

## Enumerations

enum | uhd_sensor_value_data_type_t { UHD_SENSOR_VALUE_BOOLEAN = 98 , UHD_SENSOR_VALUE_INTEGER = 105 , UHD_SENSOR_VALUE_REALNUM = 114 , UHD_SENSOR_VALUE_STRING = 115 }
| Sensor value types. More...

## Functions

UHD_API uhd_error | uhd_sensor_value_make (uhd_sensor_value_handle *h)
| Make an empty UHD sensor value.
UHD_API uhd_error | uhd_sensor_value_make_from_bool (uhd_sensor_value_handle *h, const char *name, bool value, const char *utrue, const char *ufalse)
| Make a UHD sensor from a boolean.
UHD_API uhd_error | uhd_sensor_value_make_from_int (uhd_sensor_value_handle *h, const char *name, int value, const char *unit, const char *formatter)
| Make a UHD sensor from an integer.
UHD_API uhd_error | uhd_sensor_value_make_from_realnum (uhd_sensor_value_handle *h, const char *name, double value, const char *unit, const char *formatter)
| Make a UHD sensor from a real number.
UHD_API uhd_error | uhd_sensor_value_make_from_string (uhd_sensor_value_handle *h, const char *name, const char *value, const char *unit)
| Make a UHD sensor from a string.
UHD_API uhd_error | uhd_sensor_value_free (uhd_sensor_value_handle *h)
| Free the given sensor handle.
UHD_API uhd_error | uhd_sensor_value_to_bool (uhd_sensor_value_handle h, bool *value_out)
| Get the sensor's value as a boolean.
UHD_API uhd_error | uhd_sensor_value_to_int (uhd_sensor_value_handle h, int *value_out)
| Get the sensor's value as an integer.
UHD_API uhd_error | uhd_sensor_value_to_realnum (uhd_sensor_value_handle h, double *value_out)
| Get the sensor's value as a real number.
UHD_API uhd_error | uhd_sensor_value_name (uhd_sensor_value_handle h, char *name_out, size_t strbuffer_len)
| Get the sensor's name.
UHD_API uhd_error | uhd_sensor_value_value (uhd_sensor_value_handle h, char *value_out, size_t strbuffer_len)
| Get the sensor's value.
UHD_API uhd_error | uhd_sensor_value_unit (uhd_sensor_value_handle h, char *unit_out, size_t strbuffer_len)
| Get the sensor's unit.
UHD_API uhd_error | uhd_sensor_value_data_type (uhd_sensor_value_handle h, uhd_sensor_value_data_type_t *data_type_out)
UHD_API uhd_error | uhd_sensor_value_to_pp_string (uhd_sensor_value_handle h, char *pp_string_out, size_t strbuffer_len)
| Get a pretty-print representation of the given sensor.
UHD_API uhd_error | uhd_sensor_value_last_error (uhd_sensor_value_handle h, char *error_out, size_t strbuffer_len)
| Get the last error logged by the sensor handle.

## Typedef Documentation

## uhd_sensor_value_handle

typedef struct uhd_sensor_value_t* uhd_sensor_value_handle

C-level interface for a UHD sensor.

See uhd::sensor_value_t for more details.

NOTE: Using a handle before calling a make function will result in undefined behavior.

## Enumeration Type Documentation

## uhd_sensor_value_data_type_t

enum uhd_sensor_value_data_type_t

Sensor value types.

Enumerator
UHD_SENSOR_VALUE_BOOLEAN |
UHD_SENSOR_VALUE_INTEGER |
UHD_SENSOR_VALUE_REALNUM |
UHD_SENSOR_VALUE_STRING |

## Function Documentation

## uhd_sensor_value_data_type()

UHD_API uhd_error uhd_sensor_value_data_type | ( | uhd_sensor_value_handle | h,
|  | uhd_sensor_value_data_type_t * | data_type_out )

## uhd_sensor_value_free()

UHD_API uhd_error uhd_sensor_value_free | ( | uhd_sensor_value_handle * | h | ) |

Free the given sensor handle.

Attempting to use the handle after calling this handle will result in a segmentation fault.

## uhd_sensor_value_last_error()

UHD_API uhd_error uhd_sensor_value_last_error | ( | uhd_sensor_value_handle | h,
|  | char * | error_out,
|  | size_t | strbuffer_len )

Get the last error logged by the sensor handle.

NOTE: This function will overwrite any string in the given buffer before inserting the error string.

Parameters

  h | sensor handle
  error_out | string buffer in which to place error
  strbuffer_len | buffer length

## uhd_sensor_value_make()

UHD_API uhd_error uhd_sensor_value_make | ( | uhd_sensor_value_handle * | h | ) |

Make an empty UHD sensor value.

The purpose of this call is to populate the handle with a valid sensor value object. Querying this object will always yield 'false'. Typically, this sensor value object will never be used, but it will allow the handle object to be used with sensor functions later on.

Parameters

  h | the sensor handle in which to place sensor

Returns
  UHD error code

## uhd_sensor_value_make_from_bool()

UHD_API uhd_error uhd_sensor_value_make_from_bool | ( | uhd_sensor_value_handle * | h,
|  | const char * | name,
|  | bool | value,
|  | const char * | utrue,
|  | const char * | ufalse )

Make a UHD sensor from a boolean.

Parameters

  h | the sensor handle in which to place sensor
  name | sensor name
  value | sensor value
  utrue | string representing "true"
  ufalse | string representing "false"

Returns
  UHD error code

## uhd_sensor_value_make_from_int()

UHD_API uhd_error uhd_sensor_value_make_from_int | ( | uhd_sensor_value_handle * | h,
|  | const char * | name,
|  | int | value,
|  | const char * | unit,
|  | const char * | formatter )

Make a UHD sensor from an integer.

Parameters

  h | the sensor value in which to place sensor
  name | sensor name
  value | sensor value
  unit | sensor unit
  formatter | printf-style format string for value string

Returns
  UHD error code

## uhd_sensor_value_make_from_realnum()

UHD_API uhd_error uhd_sensor_value_make_from_realnum | ( | uhd_sensor_value_handle * | h,
|  | const char * | name,
|  | double | value,
|  | const char * | unit,
|  | const char * | formatter )

Make a UHD sensor from a real number.

Parameters

  h | the sensor value in which to place sensor
  name | sensor name
  value | sensor value
  unit | sensor unit
  formatter | printf-style format string for value string

Returns
  UHD error code

## uhd_sensor_value_make_from_string()

UHD_API uhd_error uhd_sensor_value_make_from_string | ( | uhd_sensor_value_handle * | h,
|  | const char * | name,
|  | const char * | value,
|  | const char * | unit )

Make a UHD sensor from a string.

Parameters

  h | the sensor value in which to place sensor
  name | sensor name
  value | sensor value
  unit | sensor unit

Returns
  UHD error code

## uhd_sensor_value_name()

UHD_API uhd_error uhd_sensor_value_name | ( | uhd_sensor_value_handle | h,
|  | char * | name_out,
|  | size_t | strbuffer_len )

Get the sensor's name.

NOTE: This function will overwrite any string in the given buffer before inserting the sensor name.

Parameters

  h | sensor handle
  name_out | string buffer in which to place name
  strbuffer_len | buffer length

## uhd_sensor_value_to_bool()

UHD_API uhd_error uhd_sensor_value_to_bool | ( | uhd_sensor_value_handle | h,
|  | bool * | value_out )

Get the sensor's value as a boolean.

## uhd_sensor_value_to_int()

UHD_API uhd_error uhd_sensor_value_to_int | ( | uhd_sensor_value_handle | h,
|  | int * | value_out )

Get the sensor's value as an integer.

## uhd_sensor_value_to_pp_string()

UHD_API uhd_error uhd_sensor_value_to_pp_string | ( | uhd_sensor_value_handle | h,
|  | char * | pp_string_out,
|  | size_t | strbuffer_len )

Get a pretty-print representation of the given sensor.

NOTE: This function will overwrite any string in the given buffer before inserting the string.

Parameters

  h | sensor handle
  pp_string_out | string buffer in which to place pp_string
  strbuffer_len | buffer length

## uhd_sensor_value_to_realnum()

UHD_API uhd_error uhd_sensor_value_to_realnum | ( | uhd_sensor_value_handle | h,
|  | double * | value_out )

Get the sensor's value as a real number.

## uhd_sensor_value_unit()

UHD_API uhd_error uhd_sensor_value_unit | ( | uhd_sensor_value_handle | h,
|  | char * | unit_out,
|  | size_t | strbuffer_len )

Get the sensor's unit.

NOTE: This function will overwrite any string in the given buffer before inserting the sensor unit.

Parameters

  h | sensor handle
  unit_out | string buffer in which to place unit
  strbuffer_len | buffer length

## uhd_sensor_value_value()

UHD_API uhd_error uhd_sensor_value_value | ( | uhd_sensor_value_handle | h,
|  | char * | value_out,
|  | size_t | strbuffer_len )

Get the sensor's value.

NOTE: This function will overwrite any string in the given buffer before inserting the sensor value.

Parameters

  h | sensor handle
  value_out | string buffer in which to place value
  strbuffer_len | buffer length